Subject: Re: [PATCH net-next v1 1/1] net: phy: add remote fault support

From: Jakub Kicinski <[email-masked]>
Date: Tue, 14 Jun 2022 22:09:48 -0700

On Wed, 15 Jun 2022 05:37:46 +0200 Andrew Lunn wrote:
> > Does this dovetail well with ETHTOOL_A_LINKSTATE_EXT_STATE /
> > ETHTOOL_A_LINKSTATE_EXT_SUBSTATE ?
> > 
> > That's where people who read extended link state out of FW put it
> > (and therefore it's read only now).  
> 
> I did wonder about that. But this is to do with autoneg which is part
> of ksetting. Firmware hindered MAC drivers also support ksetting
> set/get.  This patchset is also opening the door to more information
> which is passed via autoneg. It can also contain the ID the link peer
> PHY, etc. This is all part of 802.3, where as
> ETHTOOL_A_LINKSTATE_EXT_STATE tends to be whatever the firmware
> offers, not something covered by a standard.

I see, yeah, I think you're right.

But I'm missing the bigger picture. I'm unclear on who is supposed 
to be setting the fault user space or kernel / device?
Reading the codes it seems like most of them are hardware related,
and would get set by the kernel? Or are they expected to be set
by user space based on SQI / tests etc.?
Even for testing kernel can set it when it changes oper_state of 
the device.